﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridDynamicColumns
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public StaffMemberViewModel ViewModel
        {
            get { return this.DataContext as StaffMemberViewModel; }
        }

        private void xamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            //a cheat to get the number of columns to create.
            var staffMember = this.ViewModel.StaffMembers.First();

            for (Int32 i = 0; i < staffMember.Periods.Count; i++)
            {
                var field = new UnboundField
                {
                    Name = staffMember.Periods[i].Title,
                    BindingPath = new PropertyPath(String.Format("Periods[{0}].Hours", i))
                };

                field.AllowEdit = false;
                field.Settings.EditAsType = typeof(Int32);
                field.Settings.EditorStyle = (Style)Resources["HoursFieldStyle"];

                e.FieldLayout.Fields.Add(field);
            }
        }

        void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            //I want to clear values
            var fieldsCount = Values.FieldLayouts.Count;
            var staffMember = this.ViewModel.StaffMembers.First();
            for (Int32 i = 2; i < Values.FieldLayouts[0].Fields.Count; i++)
            {
                    this.Values.FieldLayouts[0].Fields.RemoveAt(i);
            }
            //Get new values
            ViewModel.changeStaffMembers();

            for (Int32 i = 0; i < staffMember.Periods.Count; i++)
            {
                var field = new UnboundField
                {
                    Name = staffMember.Periods[i].Title,
                    BindingPath = new PropertyPath(String.Format("Periods[{0}].Hours", i))
                };

                field.AllowEdit = false;
                field.Settings.EditAsType = typeof(Int32);
                field.Settings.EditorStyle = (Style)Resources["HoursFieldStyle"];

                var field2 = new FieldLayout();
                field2.Fields.Add(field);
                Values.FieldLayouts.Add(field2);
            }
        }
    }
}
